#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
##
#    
#    Copyright (C) 2007  Mola Pahnadayan
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
##

import os
import pygtk
pygtk.require('2.0')

import gtk
import gtk.gdk
import datetime
import calendar
import utility
import os.path
from xml.dom.minidom import getDOMImplementation, parse
from xml.parsers.expat import ExpatError
from string import strip, lower

def _get_text(nodelist):
    rc = u""
    name = nodelist.nodeName
    for node in nodelist.childNodes:
        if node.nodeType == node.TEXT_NODE:
            rc = rc+ node.data
    return name,rc.strip()

imagelist=["balloons-aj.png","marid.png","shabdar.png","cday.png"]
extrafile = "/.jcal_extra.xml"
DATA_DIR="/usr/share/jalali-calendar"
mon_name = ["فروردین","اردیبهشت","خرداد","تیر","مرداد","شهریور"
            ,"مهر","آبان","آذر","دی","بهمن","اسفند"]
event = ["تولد","سالگرد ازدواج","وفات","بقیه موارد"]
def convert_to_str(num):
    s = str(num)
    uni_c = [u'\u06f0',u'\u06f1',u'\u06f2',u'\u06f3',u'\u06f4',u'\u06f5',u'\u06f6',u'\u06f7',u'\u06f8',u'\u06f9']
    res = u""
    if len(s)>0:
        for i in s:
            res += uni_c[int(i)]
    return res

def get_home():
        return os.environ.get('HOME', '')
    
class wmonth:
    def __init__(self):
        self.hbox=gtk.HBox()
        self.arrow_left2=gtk.Button()
        self.arrow_left2.set_relief(2)
        image=gtk.image_new_from_stock(gtk.STOCK_GO_BACK,gtk.ICON_SIZE_SMALL_TOOLBAR)
        self.arrow_left2.set_image(image)
        self.hbox.pack_start(self.arrow_left2,0,0,0)
        self.monthname=gtk.Label(" <b></b> ")
        self.monthname.set_use_markup(True)
        self.monthname.set_size_request(75,34)
        self.hbox.pack_start(self.monthname,0,0,0)
        self.arrow_right2=gtk.Button()
        self.arrow_right2.set_relief(2)
        image=gtk.image_new_from_stock(gtk.STOCK_GO_FORWARD,gtk.ICON_SIZE_SMALL_TOOLBAR)
        self.arrow_right2.set_image(image)

        self.hbox.pack_start(self.arrow_right2,0,0,0)
        self.hbox.show_all()
        
        self .label=gtk.HSeparator()
        self.hbox.pack_start(self.label,1,1,0)
        
        self.arrow_left=gtk.Button()
        self.arrow_left.set_relief(2)
        image=gtk.image_new_from_stock(gtk.STOCK_GO_BACK,gtk.ICON_SIZE_SMALL_TOOLBAR)
        self.arrow_left.set_image(image)
        self.hbox.pack_start(self.arrow_left,0,0,0)
        self.yearnum=gtk.Label(" <b></b> ")
        self.yearnum.set_use_markup(True)
        self.hbox.pack_start(self.yearnum,0,0,0)
        self.yearnum.set_size_request(45,34)
        self.arrow_right=gtk.Button()
        self.arrow_right.set_relief(2)
        image=gtk.image_new_from_stock(gtk.STOCK_GO_FORWARD,gtk.ICON_SIZE_SMALL_TOOLBAR)
        self.arrow_right.set_image(image)
        self.hbox.pack_start(self.arrow_right,0,0,0)
    
class birthdialog:
    
    def __init__(self,conf):
        self.db=None
        self.fxml = None
        self.getfile()
        self.conf = conf
        self.builder2 = gtk.Builder()
        self.builder2.add_from_file(DATA_DIR+"/dialog.glade")
        
        self.bwindow=self.builder2.get_object("eventdialog")
        self.builder2.connect_signals(self)
        
        self.vbox=self.builder2.get_object("vbox5")
        self.combobox1=self.builder2.get_object("combobox1")
        self.spinbutton1=self.builder2.get_object("spinbutton1")
        self.combobox2=self.builder2.get_object("combobox2")
        self.combobox3=self.builder2.get_object("combobox3")
        self.entry1=self.builder2.get_object("entry1")
        self.edit_but=self.builder2.get_object("button2")
        self.add_jcalendar()
        self.treestore = gtk.ListStore(gtk.gdk.Pixbuf,int,int,str,int,int)
        self.modelsort = gtk.TreeModelSort(self.treestore)
        self.modelsort.set_sort_column_id(1, gtk.SORT_ASCENDING)
        
        self.modelfilter = self.modelsort.filter_new()
        self.show_states = [1,2,3,4,5,6,7,8,9,10,11,12]
        self.show_event = [1]
        self.modelfilter.set_visible_func(self.visible_cb, self.show_states)
        
        self.treeview=self.builder2.get_object("treeview1")
        self.treeview.set_model(self.modelfilter)


        cell0 = gtk.CellRendererPixbuf()
        col = gtk.TreeViewColumn("",cell0,pixbuf = 0)
        self.treeview.append_column(col)

        cell1 = gtk.CellRendererText()
        col = gtk.TreeViewColumn("ماه",cell1,text=1)
        self.treeview.append_column(col)
        self.treeview.set_search_column(1)
        
        cell3 = gtk.CellRendererText()
        col = gtk.TreeViewColumn("روز",cell3,text=2)
        self.treeview.append_column(col)
        self.treeview.set_search_column(1)

        cell4 = gtk.CellRendererText()
        col = gtk.TreeViewColumn("توضیح",cell4,text=3)
        self.treeview.append_column(col)

        self.loadlist()
        self.selected_cursor = None
        self.combobox1.set_active(0)
        self.combobox2.set_active(3)
        self.combo3 = gtk.ListStore(str)

        self.combobox3.set_model(self.combo3)
        cellc = gtk.CellRendererText()
        self.combobox3.pack_start(cellc, True)
        self.combobox3.add_attribute(cellc, 'text', 0) 
        for i in event:
            self.combo3.append([i])
        self.bwindow.show_all()

    def visible_cb(self, model, iter, data):
        t = model.get_value(iter, 1) in data
        x = model.get_value(iter, 5) in self.show_event
        if self.builder2.get_object("checkfilter_1").get_active()==False:
            t = True
        if self.builder2.get_object("checkfilter_2").get_active():
            t = t and x
        return t

    def on_month_changed(self,obj):
        del self.show_states[:]
        self.show_states.append(obj.get_active()+1)
        self.modelfilter.refilter()
        return

    def on_event_changed(self,obj):
        del self.show_event[:]
        self.show_event.append(obj.get_active())
        self.modelfilter.refilter()

        return            
    def add_jcalendar(self):
        jdate=utility.miladi_to_jalali(datetime.date.today().year, datetime.date.today().month, datetime.date.today().day)
        
        self.year=jdate[0]
        self.month=jdate[1]
        self.day=jdate[2]
        self.header=wmonth()
        self.vbox.pack_start(self.header.hbox,0,0,0)
        
        self.header.arrow_left2.connect("clicked",self.month_prev)
        self.header.arrow_right2.connect("clicked",self.month_next)
        self.header.arrow_left.connect("clicked",self.year_prev)
        self.header.arrow_right.connect("clicked",self.year_next)
        #self.header.hbox.show_all()
        size=self.conf.get_int("/apps/jcalendar/cal_size")       
        self.cal=calendar.pcalendar(self.year,self.month,self.day,"/usr/share/jalali-calendar",self.loadcustomlist(),2)
        self.cal.set_islamic(self.conf.get_bool("/apps/jcalendar/show_Islamic"))
        self.cal.set_julian(self.conf.get_bool("/apps/jcalendar/show_Julian"))
        self.cal.set_grid(self.conf.get_bool("/apps/jcalendar/show_grid"))
        self.cal.connect("day-change",self.changeday)
#        self.cal.connect("month-change",self.monthchange)
#        self.cal.connect("day-change",self.daychange)
        #self.cal.show()
        self.vbox.pack_start(self.cal ,1 ,1, 0)
        self.header.yearnum.set_label("<b>"+convert_to_str(self.year)+"</b>")
        self.header.monthname.set_label(' <b>'+mon_name[self.month-1]+'</b> ')
                
    def changeday(self,obj=None,y=-1,m=-1,d=-1):
        iter=self.search(self.treestore,self.treestore.iter_children(None),self.match_func,[(1,m),(2,d)])
        if iter:
            pp=self.modelsort.convert_child_path_to_path(self.treestore.get_path(iter))
            self.treeview.set_cursor(pp)

        self.builder2.get_object("combobox3").set_sensitive(True)
        self.header.monthname.set_label(' <b>'+mon_name[y-1]+'</b> ')


    def match_func(self,model, iter, data):
        column1, key1 = data[0]
        column2, key2 = data[1]
        value  = model.get_value(iter, column1)
        value2 = model.get_value(iter, column2)
        return (value == key1)and(value2 == key2)

    def search(self,model, iter, func, data):
        while iter:
            if func(model, iter, data):
                return iter
            result = self.search(model, model.iter_children(iter), func, data)
            if result: return result
            iter = model.iter_next(iter)
        return None

        
    def getfile(self):
        home = get_home()
        if not(os.path.isfile(home+extrafile)):
            self.db=None
            return
        calfile=home+extrafile
        self.fxml = parse(calfile)
        self.db=self.fxml.getElementsByTagName("day")
        
    def loadcustomlist(self):
        if self.db==None:
            return None 
        full_list = []
        for record in self.db:
            list = []
            for element in record.childNodes:
                if element.nodeType != element.TEXT_NODE:
                    if element.nodeType != element.TEXT_NODE:
                        name, data = _get_text(element)
                        if (name=="num"):
                            sp=data.split("/")
                            list.append(int(sp[0]))
                            list.append(int(sp[1]))
                        if (name=="kind"):
                            list.append(int(data))
                        if (name=="desc"):
                            list.append(data)
            full_list.append(list)
        return full_list
    
    def loadlist(self):
        if (self.db==None):
            return None
        element_code=1
        pix = gtk.Image()
        for record in self.db:
            list = []
            for element in record.childNodes:
                if element.nodeType != element.TEXT_NODE:
                    if element.nodeType != element.TEXT_NODE:
                        name, data = _get_text(element)
                        if (name=="num"):
                            sp=data.split("/")
                            list.append(sp[0])
                            list.append(sp[1])
                        if (name=="kind"):
                            list.append(data)
                        if (name=="desc"):
                            list.append(data)
            try:
                file = "/usr/share/jalali-calendar"+"/"+imagelist[int(list[2])]
                pix.set_from_file(file)
                p=pix.get_pixbuf()
            except:
                p=None
            self.treestore.append([p,int(list[0]),int(list[1]),list[3],element_code,int(list[2])])
            element_code+=1
        if element_code==1:
            self.edit_but.set_property('sensitive', False)

    def on_add_clicked(self,obj,data=None):
        if not(os.path.isfile(get_home()+extrafile)):
            self.create_homefile()
        self.add()
        self.treestore.clear()
        self.getfile()
        self.loadlist()

        self.cal.set_extraday(self.loadcustomlist())
        
    def on_delete_clicked(self,obj,data=None):
        self.delete()
        self.treestore.clear()
        self.getfile()
        self.loadlist()

        self.cal.set_extraday(self.loadcustomlist())

    def on_edit_clicked(self,obj,data=None):
        self.delete()
        self.add()
        self.treestore.clear()
        self.getfile()
        self.loadlist()
        self.entry1.set_text("")

        self.cal.set_extraday(self.loadcustomlist())
        
    def add(self):
        if self.fxml==None:
            return
        newday = self.fxml.createElement("day")
        field_day = self.fxml.createElement("num")
        mon = str(self.cal.get_month())
        day = str(self.cal.get_day())
        field_day_text = self.fxml.createTextNode(mon+"/"+day)
        
        field_kind = self.fxml.createElement("kind")
        kind = str(self.combobox3.get_active())
        field_kind_text = self.fxml.createTextNode(kind)

        field_desc = self.fxml.createElement("desc")
        text = self.entry1.get_text()
        field_desc_text = self.fxml.createTextNode(text)

        field_day.appendChild(field_day_text)
        field_kind.appendChild(field_kind_text)
        field_desc.appendChild(field_desc_text)
        
        newday.appendChild(field_day)
        newday.appendChild(field_kind)
        newday.appendChild(field_desc)
        
        db2=self.fxml.getElementsByTagName("customday")[0]
        db2.appendChild(newday)
        
        libxml = open(get_home()+extrafile,'w')
        libxml.write(self.fxml.toprettyxml(" "))
        libxml.close()
        
        self.entry1.set_text("")
        
    def element_change(self,obj,data=None):
        selection=obj.get_selection()
        (mode,iter)=selection.get_selected()
        self.selected_cursor=mode.get(iter,4)[0]
        self.cal.set_month(mode.get(iter,1)[0])
        self.cal.set_day(mode.get(iter,2)[0])
        self.builder2.get_object("combobox3").set_active(mode.get(iter,5)[0])
        self.entry1.set_text(mode.get(iter,3)[0])
        self.edit_but.set_property('sensitive', True)
        
        
    def delete (self):
        if (self.db==None):
            return None
        el_code=1
        find =False
        db2=self.fxml.getElementsByTagName("customday")[0]
        for record in db2.getElementsByTagName("day"):
            for element in record.childNodes:
                if (el_code==self.selected_cursor):
                    removeday = db2.removeChild(record)
                    removeday.unlink()
                    find = True
                    break
            if find ==True:
                break
            el_code+=1

        libxml = open(get_home()+extrafile,'w')
        libxml.write(self.fxml.toprettyxml(" "))
        libxml.close()

        
    def create_homefile(self):
        xml = open(get_home()+extrafile,'w')
        xml.write('<?xml version="1.0" ?>')
        xml.write("")
        xml.write('<customday>')
        xml.write("")
        xml.write('</customday>')
        xml.close()
        self.fxml = parse(get_home()+extrafile)
    
    def on_checkfilter_2_toggled(self,obj):
        if obj.get_active():
            self.builder2.get_object("combobox2").set_sensitive(True)
        else:
            self.builder2.get_object("combobox2").set_sensitive(False)
            del self.show_states[:]
            for i in range(1,12):
                self.show_states.append(i)
            self.modelfilter.refilter()
        
        return True

    def on_checkfilter_1_toggled(self,obj):
        if obj.get_active():
            self.builder2.get_object("combobox4").set_sensitive(True)
        else:
            self.builder2.get_object("combobox4").set_sensitive(False)
            del self.show_states[:]
            for i in range(1,12):
                self.show_states.append(i)
            self.modelfilter.refilter()
        return True

    def month_next(self,obj,data=None):
        self.cal.next_month()
        month=self.cal.get_month()
        self.header.monthname.set_label(' <b>'+mon_name[month-1]+'</b> ')
        year=self.cal.get_year()
        self.header.yearnum.set_label(' <b>'+convert_to_str(year)+'</b> ')
        self.month=month

        
    def month_prev(self,obj,data=None):
        self.cal.prev_month()
        month=self.cal.get_month()
        self.header.monthname.set_label(' <b>'+mon_name[month-1]+'</b> ')
        year=self.cal.get_year()
        self.header.yearnum.set_label(' <b>'+convert_to_str(year)+'</b> ')
        self.month=month


    def year_next(self,obj,data=None):
        self.cal.next_year()
        year=self.cal.get_year()
        self.header.yearnum.set_label(' <b>'+convert_to_str(year)+'</b> ')
        self.year=year
        self.change_lable(self.day)


    
    def year_prev(self, obj, data=None):
        self.cal.prev_year()
        year=self.cal.get_year()
        self.header.yearnum.set_label(' <b>'+convert_to_str(year)+'</b> ')
        self.year=year
        self.change_lable(self.day)


    def bquit(self,obg,data=None):
        self.bwindow.destroy()