#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
##
#    
#    Copyright (C) 2007  Mola Pahnadayan
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
##

import os
import pygtk
pygtk.require('2.0')

import gtk
import gtk.gdk
import calendar
import os.path
import sys
import gconf
import locale

DATA_DIR= "/usr/share/jalali-calendar"

class dp:
    def __init__(self):
        self.builder = gtk.Builder()
        self.builder.add_from_file(DATA_DIR+"/pref.glade")
        
        self.bwindow=self.builder.get_object("preferencesdialog")

        
        self.cbutton1=self.builder.get_object("checkbutton1")
        self.conf_client = gconf.client_get_default()
        self.conf_client.add_dir("/apps/jcalendar", gconf.CLIENT_PRELOAD_NONE)
        time_show = self.conf_client.get_bool("/apps/jcalendar/show_time")
        self.cbutton1.set_active(time_show)

        self.builder.get_object("radiobutton1").set_sensitive(time_show)
        self.builder.get_object("radiobutton2").set_sensitive(time_show)
        self.builder.get_object("checkbutton2").set_sensitive(time_show)
        if self.conf_client.get_int("/apps/jcalendar/time_type"):
            self.builder.get_object("radiobutton1").set_active(True)
        else:
            self.builder.get_object("radiobutton2").set_active(True)
            
        self.builder.get_object("checkbutton7").set_active(self.conf_client.get_bool("/apps/jcalendar/show_grid"))
        self.builder.get_object("checkbutton4").set_active(self.conf_client.get_bool("/apps/jcalendar/show_Julian"))
        self.builder.get_object("checkbutton5").set_active(self.conf_client.get_bool("/apps/jcalendar/show_Islamic"))
                
        self.cbutton2=self.builder.get_object("checkbutton2")
        self.cbutton2.set_active(self.conf_client.get_bool("/apps/jcalendar/show_sec"))
                
        self.cal_size=self.conf_client.get_int("/apps/jcalendar/cal_size")
        print self.cal_size

        combo=self.builder.get_object("combobox1")
        store = gtk.ListStore(str)
        store.append (["عادی"])
        store.append (["متوسط"])
        store.append (["بزرگ"])
        store.append (["خیلی بزرگ"])
        combo.set_model(store)
        cell = gtk.CellRendererText()
        combo.pack_start(cell, True)
        combo.add_attribute(cell, 'text',0)
        combo.set_active(self.cal_size)

       
        self.builder.connect_signals(self)
        
    
    def on_okbutton1_clicked(self,obg,data=None):
        self.conf_client.set_bool("/apps/jcalendar/show_time", self.cbutton1.get_active())
        self.conf_client.set_int("/apps/jcalendar/time_type", self.builder.get_object("radiobutton1").get_active())
        self.conf_client.set_bool("/apps/jcalendar/show_sec", self.cbutton2.get_active())
        self.conf_client.set_int("/apps/jcalendar/cal_size", self.builder.get_object("combobox1").get_active())
        self.conf_client.set_bool("/apps/jcalendar/show_Islamic",self.builder.get_object("checkbutton5").get_active())
        self.conf_client.set_bool("/apps/jcalendar/show_Julian",self.builder.get_object("checkbutton4").get_active())
        self.conf_client.set_bool("/apps/jcalendar/show_grid",self.builder.get_object("checkbutton7").get_active())
        self.bwindow.destroy()
    
    def radio_check(self,obj=None,data=None):
        if obj.get_active():
            self.cal_size=int(obj.get_name()[1])
        
    def on_checkbutton1_toggled(self,object):
        time_show=object.get_active()
        self.builder.get_object("radiobutton1").set_sensitive(time_show)
        self.builder.get_object("radiobutton2").set_sensitive(time_show)
        self.builder.get_object("checkbutton2").set_sensitive(time_show)
          
    def on_preferencesdialog_destroy(self,object):
        self.bwindow.destroy()
        