#!/usr/bin/env python
###
#    
#    Copyright (C) 2007  Mola Pahnadayan
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
##

import math
import datetime

monthDays=[31, 31, 31, 31, 31, 31, 30, 30, 30, 30, 30, 29]
monthdays=[31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]

days_in_year = [365,366]
class cal:
    def __init__(self):
        self.year =0
        self.month=0
        self.day =0
        self.weekOfYear =0
        self.weekOfMonth =0
        self.dayOfYear =0
        self.dayOfWeek =0 # shanbe 0,yekshanbe 1, ... , jome 6
        self.era =0


def leap( year):
    "LEAP_jalali: Is a given year a leap year in the Jalali calendar ?"

    # Python <= 2.5
    if year > 0:
        rm = 474
    else:
        rm = 473

    # Python 2.5
    #return ((((((year - 474 if year > 0 else 473 ) % 2820) + 474) + 38) * 682) % 2816) < 682

    return ((((((year - rm) % 2820) + 474) + 38) * 682) % 2816) < 682
def scalar_Days (year,month,day): 
    year = year -475+2820
    month -= 1

    daysNo=(year/2820)*1029983
    year=year % 2820

    daysNo+=(year/128)* 46751
    if((year/128)>21):
        daysNo-=46751
        year=(year%128)+128
    else:
        year=year%128

    if(year>=29):
        year-=29
        daysNo+=10592

    if(year>=66):
        year-=66
        daysNo+=24106
    elif( year>=33):
        daysNo+=(year/33)* 12053
        year=year%33

    if (year >= 5):
        daysNo += 1826
        year -=5
    elif (year == 4):
        daysNo += 1460
        year -=4

    daysNo += 1461 * (year/4)
    year %= 4
    daysNo += 365 * year
    i=0
    while(i < month):
        daysNo += monthDays[i]
        i+=1

    daysNo += day
    return daysNo-856493

def jalalyDate (daysNo):
    h=cal()
    month=0
    day=0
    yearOffset=0
    monthOffset=0
    
    daysNo+=856493
    scalarDays=daysNo
    year=(daysNo/1029983)*2820
    daysNo=daysNo%1029983

    if((daysNo/46751)<=21):
        year+=(daysNo/46751)* 128
        daysNo=daysNo%46751
    else:
        year+=(daysNo/46751)* 128
        daysNo=daysNo%46751
        year-=128
        daysNo+=46751

    if (daysNo >= 10592):
        year+= 29
        daysNo -= 10592

        if(daysNo>=24106):
            daysNo-=24106
            year+=66

	if(daysNo>=12053):
		daysNo-=12053
		year+=33


	if (daysNo >= 1826):
		year+= 5
		daysNo -= 1826
	elif (daysNo > 1095):
		year+= 3
		daysNo -= 1095

	year +=(4 * (daysNo/1461))
	daysNo %= 1461

	if (daysNo == 0):
		year -= 1
		daysNo = 366
	else:
		year += daysNo/365
		daysNo = daysNo % 365
		if (daysNo == 0):
			year -= 1
			daysNo = 365

	h.dayOfYear=daysNo
	yearOffset=(scalarDays-h.dayOfYear+4)%7
	h.weekOfYear=(h.dayOfYear+yearOffset-1)/7+1
    
    i=0
    while((i < 11)and(daysNo > monthDays[i])):
        daysNo -= monthDays[i]
        i+=1

	month = i + 1
	day = daysNo
	h.day = day

	monthOffset=(scalarDays-h.day+4)%7

	h.weekOfMonth=(h.day+monthOffset-1)/7+1
	h.month = month
	h.year = year-2345

	if (h.year<0):
		h.era=0
	else:
		h.era=1
    h.dayOfWeek=(scalarDays+3)%7
    return h.dayOfWeek

BASE_CAL_DAY=11
BASE_CAL_MONTH=10
BASE_CAL_YEAR=1348
DAY_LEN=86400
YEAR_LEN=31557600
SEGMENT_REDIRECTION=0.70
YEAR_LEND=365.24220

GREGORIAN_EPOCH = 1721425.5
JALALI_EPOCH = 1948320.5
ISLAMIC_EPOCH = 1948439.5

def convert_to_jalali():
    gj = gregorian_to_jd(datetime.date.today().year, datetime.date.today().month, datetime.date.today().day)
    return jd_to_jalali(gj)


def gregorian_to_jd( year, month, day):
    "GREGORIAN_TO_JD: Determine Julian day number from Gregorian calendar date"
    # Python <= 2.5
    if month <= 2 :
        tm = 0
    elif leap(year):
        tm = -1
    else:
        tm = -2
        
    # Python 2.5
    #tm = 0 if month <= 2 else (-1 if self.leap_gregorian(year) else -2)
        
    return (GREGORIAN_EPOCH - 1) + (365 * (year - 1)) + math.floor((year - 1) / 4) +  (-math.floor((year - 1) / 100)) + \
           math.floor((year - 1) / 400) + math.floor((((367 * month) - 362) / 12) + tm + day)

def jalali_to_jd(year, month, day):
    "JALALI_TO_JD: Determine Julian day from Jalali date"
    # Python <= 2.5
    if year >=0 :
        rm = 474
    else:
        rm = 473
    epbase = year - (rm)
    
    # Python 2.5
    #epbase = year - 474 if year>=0 else 473
    epyear = 474 + (epbase % 2820)
    
       
    if month <= 7 :
        mm = (month - 1) * 31
    else:
        mm = ((month - 1) * 30) + 6

    return day + mm + \
            math.floor(((epyear * 682) - 110) / 2816) + \
            (epyear - 1) * 365 + \
            math.floor(epbase / 2820) * 1029983 + \
            (JALALI_EPOCH - 1)

def jd_to_jalali( jd):
    "JD_TO_JALALI: Calculate Jalali date from Julian day"

    jd = math.floor(jd) + 0.5
    depoch = jd - jalali_to_jd(475, 1, 1)
    cycle = math.floor(depoch / 1029983)
    cyear = depoch % 1029983
    if cyear == 1029982 :
        ycycle = 2820
    else :
        aux1 = math.floor(cyear / 366)
        aux2 = cyear % 366
        ycycle = math.floor(((2134 * aux1) + (2816 * aux2) + 2815) / 1028522) + aux1
    
    year = int(ycycle + (2820 * cycle) + 474)
    if year <= 0 :
        year -= 1
    
    yday = (jd - jalali_to_jd(year, 1, 1)) + 1
    if yday <= 186:
        month = int(math.ceil(yday / 31))
    else:
        month = int(math.ceil((yday - 6) / 30))
    
    day = int(jd - jalali_to_jd(year, month, 1))

    return year, month, day

def islamic_to_jd(year, month, day):
    "ISLAMIC_TO_JD: Determine Julian day from Islamic date"
    return (day + \
            math.ceil(29.5 * (month - 1)) + \
            (year - 1) * 354 + \
            math.floor((3 + (11 * year)) / 30) + \
            ISLAMIC_EPOCH) - 1

def jd_to_islamic( jd):
    "JD_TO_ISLAMIC: Calculate Islamic date from Julian day"
    
    jd = math.floor(jd) + 0.5
    year = int(math.floor(((30 * (jd - ISLAMIC_EPOCH)) + 10646) / 10631))
    month = int(min(12, math.ceil((jd - (29 + islamic_to_jd(year, 1, 1))) / 29.5) + 1))
    day = int(jd - islamic_to_jd(year, month, 1)) + 1;
    return year, month, day

def jalali_to_milady (year,month,day):
    gy= gm= gd = 0
    g_day_no = j_day_no =long()
    leap=0

    jy = year-979;
    jm = month-1;
    jd = day-1;

    j_day_no = 365*jy + (jy/33)*8 + (jy%33+3)/4
    i = 0
    while (i<jm):
        j_day_no += monthDays[i]
        i +=1

    j_day_no += jd
    g_day_no = j_day_no+79

    gy = 1600 + 400*(g_day_no/146097) 
    g_day_no = g_day_no % 146097

    leap = 1
    if (g_day_no >= 36525):
        g_day_no -=1
        gy += 100*(g_day_no/36524)
        g_day_no = g_day_no % 36524
      
        if (g_day_no >= 365):
            g_day_no +=1
        else:
            leap = 0

    gy += 4*(g_day_no/1461)
    g_day_no %= 1461

    if (g_day_no >= 366):
        leap = 0

        g_day_no -=1
        gy += g_day_no/365
        g_day_no = g_day_no % 365

    i=0
    while (g_day_no >= monthdays[i] + (i == 1 and leap)):
        g_day_no -= monthdays[i] + (i == 1 and leap)
        i+=1
    gm = i+1
    gd = g_day_no+1

    return gy,gm,gd

def miladi_to_jalali (year,month,day):
    gyear = year-1600
    gmonth = month -1
    gday = day - 1
    
    gday_no = (365*gyear)+((gyear+3)/4)-(gyear+99)/100+(gyear+399)/400

    for i in range(0,gmonth):
        gday_no+= monthdays[i]
    if (gmonth>1 and ((gyear%4==0 and gyear%100!=0)or(gyear%400==0))):
        gday_no+=1
    gday_no += gday
    
    jday_no = gday_no-79
    np = jday_no / 12053
    jday_no %= 12053
    
    jyear = 979+(33*np)+4*(jday_no/1461)
    jday_no%= 1461
    
    if (jday_no >= 366):
        jyear+=(jday_no-1)/365
        jday_no = (jday_no-1)%365
    jmonth=1
    for i in range(0,11):
        if jday_no>= monthDays[i]:
            jday_no -= monthDays[i]
            jmonth +=1
        else:
            break
    jday_no+=1
    return jyear,jmonth,jday_no
    